#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int INF = 2e9;
const ll LL_INF = 2e18;
const ld EPS = 1e-7;

vector < int > dx = {-1, 0, 1, 0};
vector < int > dy = {0, -1, 0, 1};

int n, m, fx = INF, fy = INF;
vector < string > a;

string bfs(int sx, int sy) {
    if (sx == fx && sy == fy)
        return "";
    map < pair < int, int >, int > d;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i != sx || j != sy)
                d[{i, j}] = INF;
        }
    }

    d[{sx, sy}] = 0;
    map < pair < int, int >, pair < int, int > > par;
    par[{sx, sy}] = {-1, -1};
    queue < pair < int, int > > q;
    q.push({sx, sy});

    while (!q.empty()) {
        auto elem = q.front();
        int x = elem.x, y = elem.y;
        q.pop();

//        cout << x + 1 << ' ' << y + 1 << ' ' << q.size() << endl;

        for (int i = 0; i < 4; ++i) {
            int nx = x + dx[i], ny = y + dy[i];
//            cout << nx + 1 << ' ' << ny + 1 << ' ' << i << ' ' << d[{nx, ny}] << endl;
            if (nx >= 0 && nx < n && ny >= 0 && ny < m && a[nx][ny] != '#' && d[{nx, ny}] > d[{x, y}] + 1) {
//                cout << "push " << nx + 1 << ' ' << ny + 1 << endl;
                d[{nx, ny}] = d[{x, y}] + 1;
                par[{nx, ny}] = {x, y};
                if (nx == fx && ny == fy)
                    break;
                q.push({nx, ny});
            }
        }
    }

//    cout << "OK1" << endl;

    string ret;
    int x = fx, y = fy;
    while (x != sx || y != sy) {
        auto elem = par[{x, y}];
        if (x - elem.x == 1) ret += 'B';
        else if (x - elem.x == -1) ret += 'F';
        else if (y - elem.y == 1) ret += 'R';
        else ret += 'L';
        x = elem.x;
        y = elem.y;
    }
    reverse(ret.begin(), ret.end());
    return ret;
}

void solve() {
    cin >> n >> m;

    a.resize(n);

    for (int i = 0; i < n; ++i)
        cin >> a[i];

    vector < pair < int, int > > coord;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '#') {
                coord.emplace_back(i, j);
                if ((i < fx) || (i == fx && j < fy)) {
                    fx = i;
                    fy = j;
                }
            }
        }
    }

    reverse(coord.begin(), coord.end());

    string ans;

    bool ok = false;
//    while (!ok) {
        for (int i = 0; i < coord.size(); ++i) {
            string t = bfs(coord[i].x, coord[i].y);
            for (char elem: t) {
                for (int j = 0; j < coord.size(); ++j) {
                    if (elem == 'F' && coord[j].x - 1 >= 0 && a[coord[j].x - 1][coord[j].y] != '#')
                            --coord[j].x;
                    if (elem == 'B' && coord[j].x + 1 < n && a[coord[j].x + 1][coord[j].y] != '#')
                            ++coord[j].x;
                    if (elem == 'L' && coord[j].y - 1 >= 0 && a[coord[j].x][coord[j].y - 1] != '#')
                            --coord[j].y;
                    if (elem == 'R' && coord[j].y + 1 < m && a[coord[j].x][coord[j].y + 1] != '#')
                            ++coord[j].x;
                }
            }
            ans += t;
        }
//        ok = true;
//        for (int i = 1; i < coord.size(); ++i) {
//            if (coord[i] != coord[i - 1]) {
//                ok = false;
//                break;
//            }
//        }
//    }
    int x = coord[0].x, y = coord[0].y;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (a[i][j] == '+')
                fx = i, fy = j;
    ans += bfs(x, y);
    cout << ans;
}

int main() {
//    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false), cin.tie(nullptr);
//    cout << setprecision(3) << fixed;

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
}
