#include <iostream>
#include <cmath>
#include <map>


unsigned long long getByPos(unsigned long long pos)
{
	static std::map<unsigned long long, unsigned long long> mem{ { 1, 0 } };

	auto it = mem.find(pos);
	if (it == mem.end())
	{
		unsigned long long tmp;
		for (unsigned long long i = 0; pos > (tmp = (1ull << i)); i++);

		unsigned long long val = getByPos(pos - (tmp >> 1ull)) + 1;
		mem.insert(std::pair<unsigned long long, unsigned long long>(pos, val));
		return val;
	}
	return it->second;
}


int main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);

	int n;
	std::cin >> n;

	for (int i = 0; i < n; i++)
	{
		unsigned long long pos;
		std::cin >> pos;
		std::cout << getByPos(pos) << '\n';
	}
}
