using System;
using System.Linq;
using System.Collections.Generic;

namespace A
{
	class Program
	{
		public struct SitInfo
		{
			
			public bool IsFull
			{
				get
				{
					return !AccFromRight && !AccFromLeft && IsFree;
				}
			}
			
			public bool IsHalf
			{
				get
				{
					return (!AccFromRight || !AccFromLeft) && IsFree;
				}
			}
			
			public bool IsFree
			{
				get
				{
					return Value == 0;
				}
			}
			
			public bool AccFromLeft;
			public bool AccFromRight;
			public int Value;
			
			public SitInfo(int val)
			{
				Value = val;
				AccFromLeft = false;
				AccFromRight = false;
			}
		}
		
		public static void Main(string[] args)
		{
			int n = int.Parse(Console.ReadLine());
			
			SitInfo[] sits = Console.ReadLine().Trim().Split(' ').Select(x => new SitInfo(int.Parse(x))).ToArray();
			
			var fulls = new LinkedList<int>();
			var halfs = new LinkedList<int>();
			var free = new LinkedList<int>();
			
			for (int i = 0; i < sits.Length; i++)
			{
				if (sits[i].Value != 0)
				{
					continue;
				}
				
				sits[i].AccFromLeft = i == 0 || sits[i - 1].Value != 0;
				sits[i].AccFromRight = i == sits.Length - 1 || sits[i + 1].Value != 0;
				
				if (sits[i].IsFull)
				{
					fulls.AddLast(i);
				}
				
				if (sits[i].IsHalf)
				{
					halfs.AddLast(i);
				}
				
				free.AddLast(i);
			}
			
			int k = int.Parse(Console.ReadLine());
			
			char[] students = Console.ReadLine().ToCharArray();
						
			for (int i = 0; i < k; i++)
			{
				bool fromLeft = students[i] == 'L';
				
				int sitIndex = -1;
				
				if (fulls.First != null)
				{					
					if (fromLeft)
					{
						sitIndex = fulls.First.Value;
						
						fulls.RemoveFirst();
					}
					else
					{
						sitIndex = fulls.Last.Value;
						fulls.RemoveLast();
					}
				}
								
				if (sitIndex == -1 && halfs.First != null)
				{
					if (fromLeft)
					{
						do {
							
							sitIndex = halfs.First.Value;
							halfs.RemoveFirst();
						}
						while (!sits[sitIndex].IsHalf && halfs.First != null);						
					}
					else
					{
						do {
							sitIndex = halfs.Last.Value;
							halfs.RemoveLast();
						}
						while (!sits[sitIndex].IsHalf && halfs.Last != null);	
					}
				}
				
				Console.WriteLine(sitIndex + ": " + (i + 1));
				
				if (sitIndex == -1 || (!sits[sitIndex].IsHalf && !sits[sitIndex].IsFull))
				{
					if (fromLeft)
					{
						do {
							sitIndex = free.First.Value;
							free.RemoveFirst();
						}
						while (!sits[sitIndex].IsFree);
					}
					else
					{
						do {
							sitIndex = free.Last.Value;
							free.RemoveLast();
						}
						while (!sits[sitIndex].IsFree);
					}
				}
				
				sits[sitIndex].Value = i + 1;
				
				if (sitIndex != 0)
				{
					sits[sitIndex - 1].AccFromRight = true;
				}
				
				if (sitIndex != sits.Length - 1)
				{
					sits[sitIndex + 1].AccFromLeft = true;
				}
			}
			
			string result = "";
			for (int i = 0; i < sits.Length; i++)
			{
				result += sits[i].Value + " ";
			}
			
			Console.WriteLine(result);
			Console.ReadKey(true);
		}
	}
}